package pe.so.api.formulario.postgresdao;

import org.json.JSONObject;
import pe.so.api.formulario.dao.ExcelDAO;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Timestamp;
import java.util.Date;

public class PostgreSqlExcel implements ExcelDAO{

    @Override
    public JSONObject execute_encuesta(JSONObject json) throws Exception{
        JSONObject respuesta = new JSONObject();
        Connection conexion = null;

        try {

            Date date = new Date();
            Date sqlDate = new Date(date.getTime());
            Timestamp sqlTime = new Timestamp(date.getTime());

            //private final String[] jsonString = {"p_encuesta_id","p_grupo_encuesta","p_correo_alumno"};

            int p_encuensta_id = json.isNull("p_encuesta_id") ? 0 : json.getInt("p_encuesta_id");
            String p_grupo_encuesta = json.isNull("p_grupo_encuesta") ? "" : json.getString("p_grupo_encuesta");
            String p_correo_alumno = json.isNull("p_correo_alumno") ? "" : json.getString("p_correo_alumno");

            conexion = PostgreSqlFactoryDAO.obtenerConexion("siiaa");

            String sql = "select horario.func_encuesta_procesar_alumno(?,?,?)";
            PreparedStatement ps = conexion.prepareStatement(sql);
            ps.setInt(1, p_encuensta_id);
            ps.setString(2, p_grupo_encuesta);
            ps.setString(3, p_correo_alumno);

            ResultSet rs = ps.executeQuery();

            if (rs.next()) {
                int columnCount = rs.getMetaData().getColumnCount();
                for (int i = 1; i <= columnCount; i++) {
                    respuesta.put(rs.getMetaData().getColumnName(i), rs.getObject(i));
                }
            }
            respuesta.put("status", true);

        } catch (Exception e) {
            respuesta.put("status", false);
            respuesta.put("mensaje", e.getMessage());
        }finally{
            if (conexion != null) {
                conexion.close();
            }
        }
        return respuesta;
    }

    @Override
    public JSONObject execute_balotario(JSONObject json) throws Exception{
        JSONObject respuesta = new JSONObject();
        Connection conexion = null;

        try {

            Date date = new Date();
            java.sql.Date sqlDate = new java.sql.Date(date.getTime());
            java.sql.Timestamp sqlTime = new java.sql.Timestamp(date.getTime());

            /*p_drive_respuesta text, p_fila_drive integer, p_correo_alumno character varying, p_nota character varying, p_apellidos character varying, p_nombres character varying, p_sede character varying*/

            String p_drive_respuesta = json.isNull("p_drive_respuesta") ? "" : json.getString("p_drive_respuesta");
            int p_fila_drive = json.isNull("p_fila_drive") ? 0 : json.getInt("p_fila_drive");
            String p_correo_alumno = json.isNull("p_correo_alumno") ? "" : json.getString("p_correo_alumno");
            String p_nota = json.isNull("p_nota") ? "" : json.getString("p_nota");
            String p_apellidos = json.isNull("p_apellidos") ? "" : json.getString("p_apellidos");
            String p_nombres = json.isNull("p_nombres") ? "" : json.getString("p_nombres");
            String p_sede = json.isNull("p_sede") ? "" : json.getString("p_sede");


            conexion = PostgreSqlFactoryDAO.obtenerConexion("siiaa");

            String sql = "select academico.func_balotario_procesar_alumno(?,?,?,?,?,?,?)";
            PreparedStatement ps = conexion.prepareStatement(sql);
            ps.setString(1, p_drive_respuesta);
            ps.setInt(2, p_fila_drive);
            ps.setString(3, p_correo_alumno);
            ps.setString(4, p_nota);
            ps.setString(5, p_apellidos);
            ps.setString(6, p_nombres);
            ps.setString(7, p_sede);

            ResultSet rs = ps.executeQuery();

            if (rs.next()) {
                int columnCount = rs.getMetaData().getColumnCount();
                for (int i = 1; i <= columnCount; i++) {
                    respuesta.put("mensaje", rs.getObject(i));
                }
            }
            respuesta.put("status", true);

        } catch (Exception e) {
            respuesta.put("status", false);
            respuesta.put("mensaje", e.getMessage());
        }finally{
            if (conexion != null) {
                conexion.close();
            }
        }
        return respuesta;
    }

    public JSONObject ejecutar(JSONObject json) throws Exception {

        JSONObject respuesta = new JSONObject();
        Connection conexion = null;

        try {

            Date date = new Date();
            java.sql.Date sqlDate = new java.sql.Date(date.getTime());
            java.sql.Timestamp sqlTime = new java.sql.Timestamp(date.getTime());

            // String[] jsonString = {"p_drive_origen", "p_drive_fila", "p_fecha_hora_registro", "p_sede", "p_medio_atencion", "p_contacto_nombres", "p_contacto_apellidos", "p_numero_documento", "p_contacto_correo", "p_contacto_telefono", "p_distrito", "p_grado", "p_colegio_procedencia","p_medio_difusion_nombre", "p_atencion_usuario", "p_atencion_fecha", "p_atencion_estado", "p_atencion_medio_atencion", "p_atencion_hora", "p_atencion_observacion"};

            String p_drive_origen = json.getString("p_drive_origen");
            int p_drive_fila = json.getInt("p_drive_fila");
            String p_fecha_hora_registro = json.isNull("p_fecha_hora_registro") ? sqlTime.toString() : json.getString("p_fecha_hora_registro");
            String p_sede = json.getString("p_sede");
            String p_medio_atencion = json.getString("p_medio_atencion");
            String p_contacto_nombres = json.getString("p_contacto_nombres");
            String p_contacto_apellidos = json.getString("p_contacto_apellidos");
            String p_numero_documento = json.getString("p_numero_documento");
            String p_contacto_correo = json.getString("p_contacto_correo");
            String p_atencion_usuario = json.getString("p_atencion_usuario");
            String p_grado = json.getString("p_grado");
            String p_contacto_telefono = json.getString("p_contacto_telefono");
            String p_colegio_procedencia = json.getString("p_colegio_procedencia");
            String p_distrito = json.getString("p_distrito");
            String p_atencion_fecha = json.getString("p_atencion_fecha");
            String p_atencion_estado = json.getString("p_atencion_estado");
            String p_atencion_medio_atencion = json.getString("p_atencion_medio_atencion");
            String p_atencion_hora = json.getString("p_atencion_hora");
            String p_atencion_observacion = json.getString("p_atencion_observacion");
            String p_medio_difusion_nombre = json.getString("p_medio_difusion_nombre");

            conexion = PostgreSqlFactoryDAO.obtenerConexion("siiaa");

            String sql = "select matricula.func_informe_registrar(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
            PreparedStatement ps = conexion.prepareStatement(sql);
            ps.setString(1, p_drive_origen);
            ps.setInt(2, p_drive_fila);
            ps.setString(3, sqlTime.toString());
            ps.setString(4, p_sede);
            ps.setString(5, p_medio_atencion);
            ps.setString(6, p_contacto_nombres);
            ps.setString(7, p_contacto_apellidos);
            ps.setString(8, p_numero_documento);
            ps.setString(9, p_contacto_correo);
            ps.setString(10, p_contacto_telefono);
            ps.setString(11, p_distrito);
            ps.setString(12, p_grado);
            ps.setString(13, p_colegio_procedencia);
            ps.setString(14, p_medio_difusion_nombre);
            ps.setString(15, p_atencion_usuario);
            ps.setString(16, p_atencion_fecha);
            ps.setString(17, p_atencion_estado);
            ps.setString(18, p_atencion_medio_atencion);
            ps.setString(19, p_atencion_hora);
            ps.setString(20, p_atencion_observacion);

            ResultSet rs = ps.executeQuery();

            if (rs.next()) {
                int columnCount = rs.getMetaData().getColumnCount();
                for (int i = 1; i <= columnCount; i++) {
                    respuesta.put(rs.getMetaData().getColumnName(i), rs.getObject(i));
                }

                if(respuesta.getString("func_informe_registrar").contains("_informe_id")){
                    respuesta.put("status", true);
                }else{
                    respuesta.put("status", false);
                }

            }

        } catch (Exception e) {
            respuesta.put("status", false);
            respuesta.put("mensaje", e.getMessage());
        }finally{
            if (conexion != null) {
                conexion.close();
            }
        }
        return respuesta;
    }



}
